/*
 * auditor.c
 * Copyright (C) 2005-2006 Robin KAY. All rights reserved.
 *
 * The contents of this file are subject to the terms of the
 * Common Development and Distribution License, Version 1.0 only
 * (the "License").  You may not use this file except in compliance
 * with the License.
 */

#include "compat.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <link.h>
#include <unistd.h>

#include "utils.h"

static path_buf_t obj_path;

uint_t la_version(uint_t version)
{
  path_rewrite_init(&readlink);
  
  return LAV_CURRENT;
}

static int objsearch_cb(
  const char *path, const char *vpath, int pflags, void *cb_data)
{
  int retval;

  retval = access(path, F_OK);
  if (retval >= 0) {
    if (path != obj_path.buf) {
      path_set(&obj_path, path);
    }
  }
  return retval;
}

char *la_objsearch(const char *name, uintptr_t *cookie, uint_t flags)
{
  if (name[0] == '/') {
    path_set(&obj_path, name);
    if (!path_rewrite(&obj_path, REWRITE_FLAGS_NONE, &objsearch_cb, NULL)) {
      return path_get_cstr(&obj_path);
    }
    else {
      return NULL;
    }
  }
  else {
    // Pass through names which are not absolute paths
    return (char *)name;
  }
}
